#include "math.h"
#include "Osc.h"

typedef struct  { double r; double i; } complex;

int TFenetre::Periode(double* val, int taille, int k) // val =
                                        //tableau ; taille = taille de val
                                       // k = position pur calcul
{
double moyenne, temps = 0;

for(int i =0; i<taille; i++)
        {
        temps = temps + val[i];
        }
moyenne = temps / taille;

// recherche des passages x >= moyenne >= y
int j = 0;
double Tablo[3];
//double Calcul[taille];        //a adapter avec dynamique
double * Calcul = new double[taille];
int i=k;
int L=0;
int var_Periode=0;
while (i < taille)
        {  j=0;
        if(val[i] <= moyenne)
                {
                while(val[i] <= moyenne+3 && i < taille) i++;
                Tablo[j] = i; j++;
                while(val[i] >= moyenne-3 && i < taille) i++;
                Tablo[j] = i; j++;
                while(val[i] <= moyenne+3 && i < taille) i++;
                Tablo[j] = i;
                }
        else    {
                while(val[i] >= moyenne-3 && i < taille) i++;
                Tablo[j] = i; j++;
                while(val[i] <= moyenne+3 && i < taille) i++;
                Tablo[j] = i; j++;
                while(val[i] >= moyenne-3 && i < taille) i++;
                Tablo[j] = i;
                }
        if (i<taille) {Calcul[L] = Tablo[2] - Tablo[0];
        i=i-2  ;
        L++;
        }
        }

if (L <= 1) {delete Calcul; return -1;}
else {
for (int m=0;m<L;m++) var_Periode = var_Periode + Calcul[m];
var_Periode = var_Periode/(L);
delete Calcul;
return var_Periode;
}
}

void __fastcall initind(int * inv,int n)
{
  if ( n == 1 ) return;
  int * T = new int[n];
  int p = 0;
  for (int i = 0 ; i < n ; i+= 2) { T[p]=inv[i]; p++;}
  for (int i = 1 ; i < n ; i+= 2) { T[p]=inv[i]; p++;}
  memcpy(inv,T,sizeof(int)*n);
  delete T;
  initind(inv,n/2);
  initind(inv+n/2,n/2);
}

void inline MUL(complex & R, complex & A, complex & B)
{
  R.r = A.r*B.r - A.i*B.i;
  R.i = A.r*B.i + A.i*B.r;
}

void inline ADD(complex & R, complex & A, complex & B) { R.r = A.r+B.r;  R.i = A.i+B.i; }
void inline SUB(complex & R, complex & A, complex & B) { R.r = A.r-B.r;  R.i = A.i-B.i; }

// x(k) = x(n-k)
// on n'a l'information pour

// retourne les composantes du signal de 0  NB/2-1, soit nb coefs


void TFenetre::FFTiter(double * signal ,const int n , double* fft)
{
  int * inv = new int[n];
  Fori(n) inv[i]=i;
  initind(inv,n);

  complex * A = (complex *) fft;
  for ( int i = 0 ; i < n ; i++ )
  {   A[inv[i]].r = signal[i];  A[inv[i]].i =  0.0; };
  int m = 2;
  while ( m <= n)
  {
    complex wm = { cos(2.0*M_PI/m) , sin(2.0*M_PI/m) };
    for (int k = 0 ; k < n ; k += m)
    {
      complex w = { 1.0 , 0.0 };
      for (int j = 0 ; j < m/2 ; j++ )
      {
        complex t,u;
        MUL(t,w,A[k+j+m/2]);
        u = A[k+j];
        ADD(A[k+j],u,t);
        SUB(A[k+j+m/2],u,t);
        MUL(t,w,wm);
        w = t;
      }
    }
    m = m * 2;
  }
  for (int i = 2; i < 2*n ; i++) fft[i] = fft[i]/(n/2.0);
  fft[0] /= n; fft[1] /= n;
  delete [] inv;
}

void TFenetre::MinMax(double &max, double &min)
{
 // trouver la moyenne et les amplitudes
min = val[0]; max = val[0];
for(int i =0; i<N; i++)
        {
         if (val[i]<min) min = val[i];
         if (val[i]>max) max = val[i];
        }
}

int TFenetre::Trigger(int Sensibilite_Trig)
{
 int trigger = 0;
 int trigger_temp = 0;
 int Trigger_Plus = ((HAUTEUR-ScrollBar_Trigger->Position)+Sensibilite_Trig);
 int Trigger_Moins = ((HAUTEUR-ScrollBar_Trigger->Position)-Sensibilite_Trig);

 if((HAUTEUR-ScrollBar_Trigger->Position)<max && (HAUTEUR-ScrollBar_Trigger->Position)>min)
        while(trigger_temp<(N-LARGEUR))
        {
                if(Trigger_Plus>val[trigger_temp]
                && val[trigger_temp]>Trigger_Moins)
                        if(val[trigger_temp+5]>val[trigger_temp])
                        {trigger = trigger_temp;
                        trigger_temp = N-LARGEUR;
                        }
        trigger_temp++;
        }

 else trigger = 0;

 return trigger;

}

void TFenetre::CharToDouble(unsigned char * signal,double * val)
{
        for(int i=0;i<N;i++)
        val[i]=signal[i+1];
}



