//---------------------------------------------------------------------------
//
//      Threads rigolos
//
//---------------------------------------------------------------------------

#include "Osc.h"

//---------------------------------------------------------------------------
// Thread Lecture
//---------------------------------------------------------------------------

DWORD __stdcall TFenetre::Thread_Lect(LPVOID lpParam) {

HANDLE hEvents[2];
DWORD event;
bool fini = false;

while(!fini) {
        hEvents[1]=Fenetre->Event[DEB_LEC];  // :)
        hEvents[0]=Fenetre->Event[STOP_LEC]; // :'(
        //on attend le bedut d'une ecr :) ou la fin :'(
        event = WaitForMultipleObjects(2,hEvents,FALSE,INFINITE);
        switch(event) {
        case WAIT_OBJECT_0:
                //fin du thread :'((
                fini = true;
                break;
        case WAIT_OBJECT_0+1:
                //c'est le bdut de la lecture :) !
                WaitForSingleObject(Fenetre->mutex_lec,INFINITE);
                if(!Fenetre->Lit_Serie()) Fenetre->res_lec = LEC_PB;
                else Fenetre->res_lec = LEC_OK;
                SetEvent(Fenetre->Event[LEC_FIN]);
                ReleaseMutex(Fenetre->mutex_lec);
                break;
        default:
                fini = true;
                break;
        }// fin switch deb lec ou fin :((
} //fin boucle infinie :)

//evenement lect fini actif
SetEvent(Fenetre->Event[TH_LEC_FINI]);
//fin du thread
return 0;
}

//---------------------------------------------------------------------------
// Thread Ecriture
//---------------------------------------------------------------------------

//DWORD WINAPI  Thread_Ecr(LPVOID lpParam) {
DWORD __stdcall TFenetre::Thread_Ecr(LPVOID lpParam) {
HANDLE hEvents[2];
DWORD event;
bool fini = false;

while(!fini) {
        hEvents[1]=Fenetre->Event[DEB_ECR];  // :)
        hEvents[0]=Fenetre->Event[STOP_ECR]; // :'(
        //on attend le bedut d'une ecr :) ou la fin
        event = WaitForMultipleObjects(2,hEvents,FALSE,INFINITE);
        switch(event) {
        case WAIT_OBJECT_0:
                //fin
                fini = true;
                break;
        case WAIT_OBJECT_0+1:
                //c'est le bdut de l'ecriture :) !
                if(!Fenetre->Ecrit_Serie()) Fenetre->res_ecr = ECR_PB;
                else Fenetre->res_ecr = ECR_OK;
                SetEvent(Fenetre->Event[ECR_FIN]);
                break;
        default:
                fini = true;
                break;
        }// fin switch deb ecr ou fin
} //fin boucle infinie

SetEvent(Fenetre->Event[TH_ECR_FINI]);
//le thread est dcd mais il n'a pas souffert
//il faudra prevenir ses parents
return 0;
}

//---------------------------------------------------------------------------
// Ecrivez moi....
//---------------------------------------------------------------------------

bool TFenetre::Ecrit_Serie()  {


HANDLE hEvents[2];
DWORD event;
DWORD ecrit;

//ResetEvent(Event[ECR_FIN]);

if(!WriteFile(hPortSerie,&buffer_e,1,&ecrit,&ovlpe))
{
        if(GetLastError()!=ERROR_IO_PENDING) //pas en attente, gros pb
        return false;

        else { //traitement en attente
                hEvents[0]=Event[STOP_ECR];  // :(
                hEvents[1]=ovlpe.hEvent; // yeah ! :)
                event = WaitForMultipleObjects(2,hEvents,FALSE,3000);
                switch(event) {

                case WAIT_OBJECT_0: //fin du prgm ou arret de l'ecr
                        return true;

                case WAIT_OBJECT_0+1: //fin de l'ecr, test si ok
                        if(!(GetOverlappedResult(hPortSerie,&ovlpe,&ecrit,FALSE) && ecrit ==1))
                        //ecriture pb
                        return false;
                        break;
                default: return false;
                        //break;
                }// fin switch
        }//fin else traitement attente
}//fin write file, normalement ok

if(ecrit !=1) return false; //on sait jamais... :)
else return true; 
}


//---------------------------------------------------------------------------
// Lit des octets sur le porc
//---------------------------------------------------------------------------

bool TFenetre::Lit_Serie()  {

HANDLE hEvents[2];
DWORD event;
DWORD lu;

if(!ReadFile(hPortSerie,buffer_l,nb_a_lire,&lu,&ovlpl))
{
        if(GetLastError()!=ERROR_IO_PENDING) //ya une grosse yaitsa
        return false;

        else { //traitement en attente
                SetEvent(Event[LEC_ATTENTE]);
                hEvents[0]=Event[STOP_LEC];  // :(
                hEvents[1]=ovlpl.hEvent; // yeah ! :)
                event = WaitForMultipleObjects(2,hEvents,FALSE,Lec_TimeOut);
                switch(event) {

                case WAIT_OBJECT_0: //fin du prgm ou arret de la lect
                buffer_l[0] = NULL;
                return false;

                case WAIT_OBJECT_0+1: //fin de la lect, test si ok
                if(!(GetOverlappedResult(hPortSerie,&ovlpl,&lu,FALSE) && lu == (DWORD)nb_a_lire))
                //lec pb
                { buffer_l[0] = NULL; return false;}
                break;
                case WAIT_TIMEOUT:
                return false;
                default:
                buffer_l[0] = NULL;
                return false;
                }// fin switch
        }//fin else traitement attente

}
SetEvent(Event[LEC_ATTENTE]);
if(lu != (DWORD)nb_a_lire) { buffer_l[0] = NULL; return false;} //on sait jamais... :)
else return true;
}

//---------------------------------------------------------------------------
// Lit qqch, fonction generale
//---------------------------------------------------------------------------

bool TFenetre::Lit_Vals(int nb)  {
if(!carte_ok) return false;

if(ModeTmp[tmp_div].val_mode != INFINI) {

if(Commande(ModeV[v_div].mode) != ModeV[v_div].mode) return false;

if(Commande(ModeTmp[tmp_div].mode) != ModeTmp[tmp_div].mode) return false;


nb_a_lire = nb+1;
SetEvent(Event[DEB_LEC]);
WaitForSingleObject(Event[LEC_ATTENTE],INFINITE);

if(!Ecrit((unsigned char)ModeTmp[tmp_div].val_mode)) return false;

WaitForSingleObject(Event[LEC_FIN],INFINITE);
return (res_lec==LEC_OK);

}

else { //mode rapide

if(Commande(ModeV[v_div].mode) != ModeV[v_div].mode) return false;
nb_a_lire = nb+1;
SetEvent(Event[DEB_LEC]);
WaitForSingleObject(Event[LEC_ATTENTE],INFINITE);
if(!Ecrit(ModeTmp[tmp_div].mode)) return false;

WaitForSingleObject(Event[LEC_FIN],INFINITE);
return (res_lec==LEC_OK);

}
}

//---------------------------------------------------------------------------
// Lit qqch, une seule fois !
//---------------------------------------------------------------------------

bool TFenetre::Trig_Vals()  {

HANDLE hEvents[2];
DWORD event;

//si pas de carte, give up
if(!carte_ok) return false;

// active trigger
if(Commande(TRIGGER) != TRIGGER) return false;

//valeur du trigger
if(Commande(HAUTEUR-ScrollBar_Trigger->Position) != TRIGGER) return false;

// volts /div
if(Commande(ModeV[v_div].mode) != ModeV[v_div].mode) return false;

//mode lent...
if(Commande(ModeTmp[tmp_div].mode) != ModeTmp[tmp_div].mode) return false;

nb_a_lire = N+1;
SetEvent(Event[DEB_LEC]);
WaitForSingleObject(Event[LEC_ATTENTE],INFINITE);

if(!Ecrit((unsigned char)ModeTmp[tmp_div].val_mode)) return false;

hEvents[0]=Event[LEC_FIN];  // :(
hEvents[1]=Event[TRIG_OFF];

event = WaitForMultipleObjects(2,hEvents,FALSE,INFINITE);
switch(event) {

case WAIT_OBJECT_0: //fin du prgm ou arret de la lect
        return (res_lec==LEC_OK);

case WAIT_OBJECT_0+1: //fin de la lect, test si ok
        return true;
default:
return false;
}// fin switch
}

//---------------------------------------------------------------------------
// Envoie une commande et retourne la reponse
//---------------------------------------------------------------------------

char TFenetre::Commande(char buffer)  {
nb_a_lire = 1;
SetEvent(Event[DEB_LEC]);
WaitForSingleObject(Event[LEC_ATTENTE],INFINITE);
if(!Ecrit(buffer))
        buffer_l[0] = NULL;
        else
        WaitForSingleObject(Event[LEC_FIN],INFINITE);
return buffer_l[0];
}

//---------------------------------------------------------------------------
// Ecrit qqch, fonction simple
//---------------------------------------------------------------------------

bool TFenetre::Ecrit(unsigned char buffer)  {
buffer_e = buffer;
SetEvent(Event[DEB_ECR]);
WaitForSingleObject(Event[ECR_FIN],INFINITE);
return (res_ecr==ECR_OK);
}
